/* Declarations for file retrieval.
   Copyright (C) 1995,96  Hrvoje Niksic
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef RETR_H
#define RETR_H

#ifdef TIME_WITH_SYS_TIME
#  include <sys/time.h>
#  include <time.h>
#else /* not TIME_WITH_SYS_TIME_H */
#ifdef HAVE_SYS_TIME_H
#  include <sys/time.h>
#else /* not HAVE_SYS_TIME_H */
#  include <time.h>
#endif /* HAVE_SYS_TIME_H */
#endif /* TIME_WITH_SYS_TIME_H */

/* Input chunk size for buffered input. */
#define INPUT_BUFFER_SIZE 4096

/* Size of buffer for file copying used for file://. */
#define FILE_BUFSIZ 1024

/* Function declarations */
int buf_readchar(int, char *);
int buf_flush(char *, int);
void buf_discard(void);

int get_contents(int, FILE *, long *, long);
int show_progress(long, int);


uerr_t retrieve_url(const char *, char **, char **, const char *, int *);
uerr_t retrieve_from_file(const char *, int, int *);

void printwhat(int, int);
char *time_str(time_t *);
char *rate(long, long);

#endif /* RETR_H */
