/* Miscellaneous declarations.
   Copyright (C) 1995,96  Hrvoje Niksic
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef WGET_H
#define WGET_H


/* Macro definitions */
#ifdef DEBUG
#  define DEBUGP(x) do { if (opt.debug) { fprintf(opt.lfile, "%s", x);}} while (0)
#else
#  define DEBUGP(x) do { } while (0)
#endif

#ifdef DEBUG
#  define CLOSE(x)                                                 \
   do {                                                            \
      close(x);                                                    \
      if (opt.debug) fprintf(opt.lfile, "Closing fd %d\n", x);     \
   } while (0)
#else
#  define CLOSE(x) close(x)
#endif

/* Document-type flags */
enum {
   TEXTHTML      = 0x0001,      /* Document is of type text/html */
   RETROKF       = 0x0002,      /* Retrieval was OK */
   HEAD_ONLY     = 0x0004,      /* Only send the HEAD request. */
   SEND_NOCACHE  = 0x0008,      /* Send Pragma: no-cache directive. */
   ACCEPTRANGES  = 0x0010       /* Accept-ranges header was found. */
};

/* Universal error type -- used almost everywhere */
typedef enum {NOCONERROR, HOSTERR, CONSOCKERR, CONERROR,
	      CONREFUSED, NEWLOCATION, NOTENOUGHMEM, CONPORTERR,
	      BINDERR, BINDOK, LISTENERR, ACCEPTERR, ACCEPTOK,
	      CONCLOSED, FTPOK, FTPLOGINC, FTPLOGREFUSED, FTPPORTERR,
              FTPNSFOD, FTPRETROK, FTPUNKNOWNTYPE, FTPRERR,
              FTPREXC, FTPSRVERR, FTPRETRINT, FTPRESTFAIL,
	      URLOK, URLHTTP, URLFTP, URLFILE, URLUNKNOWN, URLBADPORT,
	      URLBADHOST, FOPENERR, FWRITEERR, HOK, HLEXC, HEOF,
	      HERR, RETROK, RECLEVELEXC, FTPACCDENIED, WRONGCODE,
	      RETRFINISHED, READERR, TRYLIMEXC, URLBADPATTERN,
              FILEBADFILE, RANGEERR, RETRBADPATTERN, RETNOTSUP,
	      ROBOTSOK, NOROBOTS, PROXERR, QUOTEXC, WRITEFAILED } uerr_t;


#endif /* WGET_H */
